#include <psvga.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>

volatile unsigned long counter = 0;
static void interrupt (far *oldtimer)(...);
//unsigned char far* screen =
//  (unsigned char far*) ((void _seg*)(0xA000) + (void near*)(0));

static void interrupt newtimer (...) {
  asm sti;
  counter ++;
  oldtimer ();
}

void disp (FILE *file) {
  unsigned x, y, i, j;
  char c;
  fseek (file, 0, 0);
  fread (&x, 2, 1, file);
  fread (&y, 2, 1, file);
  y %= 256;
      asm   mov dx, 0x03DA   // vwait
  v1: asm { in  al, dx
	    and al, 8
	    jz  v1 }
  v2: asm { in  al, dx
	    and al, 8
	    jz  v2 }
  for (i = 0; i < 256; i++) {
    outp (0x3c8, i);
    for (j=0; j<3; j++) {
      fread (&c, 1, 1, file);
      outp (0x3c9, c);
    }
  }
  for (i = 0; i <= x; i++)
    for (j = 0; j <= y; j++)
      fread (&c, 1, 1, file);
      pset (i,j,c);
  fclose (file);
}

void main () {
  unsigned long tick = 0, ws = 2, wl=10;
  char tmp, pos, cmd[13], anim, g,
       list[10] = "gdisp.lst", pics[75][37], rd = 0, max = 0, ly = 0;
  int  i, y, rdm = 0;
  FILE* file = fopen (list, "rb");
  oldtimer = getvect(8);
  asm cli;
  setvect (8, newtimer);
  asm sti;

  randomize ();
  do {
    for (i=0; i<9; i++) {
      fread (&rd, 1, 1, file);
      if (rd == ' ') pics [max][i] = 0;
      else pics [max][i] = rd;
    }
    while (rd != 0x0a) {
      fread (&rd, 1, 1, file);
      pics [max][i] = rd;
      i++;
    }
    pics [max][i] = 0;
    max++;
  } while (pics[max-1][0] != '*');
  fclose (file);
  max-=2;

  begin:
  if (rdm) goto randy;
  asm { mov ax, 3; int 0x10 }
  for (i = 0; i<=max; i++) {
    gotoxy ((i / 24) * 25 + 1, i % 24 + 1);
    cprintf ("%s", &pics[i][9]);
  }
  do {
    textcolor (15); textbackground (1);
    gotoxy ((ly / 24) * 25 + 1, ly % 24 + 1); cprintf ("%s", &pics[ly][9]);
    g = getch (); if (g == 0) g = getch ();
    textcolor (7); textbackground (0);
    gotoxy ((ly / 24) * 25 + 1, ly % 24 + 1); cprintf ("%s", &pics[ly][9]);
    switch (g) {
      case 'H': if (ly>0) ly--; break;
      case 'P': if (ly<max) ly++; break;
      case 'K': ly -= 24; if (ly<0) ly = 0; break;
      case 'M': ly += 24; if (ly>max) ly = max; break;
      case 'G': ly=0; break;
      case 'O': ly=max; break;
      case 'r': rdm=1; g=13; break;
      case 27:  asm { mov ax, 3; int 0x10; cli }
        setvect (8, oldtimer);
        asm sti;
        exit (0);
    }
  } while (g != 13);

  randy: if (rdm) ly=random(max);

  if (pics[ly][0] == '.') goto begin;

  pos = 0;
  do {
    cmd [pos] = pics [ly][pos];
    pos ++;
  } while (pics[ly][pos] != 0);
  cmd[pos] = '.'; cmd[pos+1] = 'S'; cmd[pos+2] = 'C';
  pos += 3; cmd[pos] = 'A'; cmd [pos+1] = 0;
  tick = counter + ws; anim = 0;

  cycle:
  file = fopen (cmd, "rb");
  if (file == NULL) switch (anim) {
    case 1: if (rdm) goto begin;
      cmd[pos] = 'A';
      file = fopen (cmd, "rb");
      if (file == NULL) goto begin;
      break;
    case 2: cmd[pos] -= 2; anim = 3;
      file = fopen (cmd, "rb");
      if (file != NULL) break;
    default: goto begin;
  }

  if (anim == 0) {
    asm { mov ax, 0x13; int 0x10 }
    fread (&y, 2, 1, file); fread (&y, 2, 1, file);
    if (y > 511) anim = 2;
    else if (y > 255) anim = 1;
    else tick += wl;
  }
  disp (file);
  while (counter < tick) {
    if (kbhit ()) tmp = getch ();
    else tmp = 0;
    if (tmp == 27 || tmp == 13) { rdm = 0; goto begin; }
  }
  tick = counter + ws;
  if (anim == 3) {
    cmd[pos] --;
    if (cmd[pos] == '@') {
      cmd[pos] = 'B';
      anim = 2; if (rdm) goto begin;
    }
  } else cmd[pos] ++;
  goto cycle;
}
